{   SdlExample. Used to check units SDL and SDLGfx

    Copyright (C) 2002 by Eike Lange (eike@gnu.de)
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, version 2.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING. If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
    As a special exception, if you incorporate even large parts of the
    code of this demo program into another program with substantially
    different functionality, this does not cause the other program to
    be covered by the GNU General Public License. This exception does
    not however invalidate any other reasons why it might be covered
    by the GNU General Public License.
}

{ compile this program the usual way:
  gpc --automake sdlex.pas -o sdlex
}

program SdlEx;

uses Sdl, SdlGfx, GPC;

var
  Info: PSdlVideoInfo;
  Screen: PSdlSurface;
  Bpp, i: Integer;
  Flags: Cardinal;
  Event: TSdlEvent;
  Finished: Boolean Value False;
  ax, ay: TPolyArray;

begin
  for i := 0 to 24 do
    begin
      ax[i] := i + 300;
      ay[i] := i * 5
    end;
  if SdlInit (SdlInitVideo) < 0 then
    begin
      WriteLn (StdErr, 'SdlInit failed: ', SdlGetError);
      Halt
    end;
  AtExit (SdlQuit);
  Info := SdlGetVideoInfo;
  if Info^.VFmt^.BitsPerPixel > 8 then
    Bpp := Info^.VFmt^.BitsPerPixel
  else
    Bpp := 16;
  Flags := SdlHWSURFACE or SdlFULLSCREEN;
  Screen := SdlSetVideoMode (800, 600, Bpp, Flags);
  if Screen = Nil then
    begin
      WriteLn (StdErr, 'SdlSetVideoMode failed: ', SdlGetError);
      Halt
    end;
  StringRGBA (Screen, 10, 10, 'Press a key to exit',
    200, 200, 200, 200);
  StringRGBA (Screen, 10, 20, 'Press mouse to draw some rects',
    200, 200, 200, 100);
  SdlUpdateRect (Screen, 0, 0, 0, 0);
 
  repeat
    SdlDelay (100);
    while SdlPollEvent (Event) do
      begin
        if (Event.aType = SdlQuitEvent) or (Event.aType = SdlKeyDown) then
          Finished := True
        else if Event.aType = SdlMouseButtonDown then
          begin
            FilledPolygonColor (Screen, ax, ay, 25, 16#aaff00ff);
            RectangleRGBA (Screen, 0, 0, 799, 599, 16#ff, 0, 0, 16#ff);
            RectangleRGBA (Screen, 100, 100, 799, 599, 0, 16#ff, 0, 16#ff);
            RectangleRGBA (Screen, 300, 300, 799, 599, 0, 0, 16#ff, 16#ff);
            SdlUpdateRect (Screen, 0, 0, 0, 0)
          end
      end
  until Finished
end.
